//---------------------------------------------------------------------------
/*
Copyright (c) 2013 Serge L. Ryadkow admin@opcgate.ru http://opcgate.ru 

Permission is hereby granted, free of charge, to any person obtaining a copy of this 
software and associated documentation files (the "Software"), to deal in the Software 
without restriction, including without limitation the rights to use, copy, modify, 
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to 
permit persons to whom the Software is furnished to do so, subject to the following 
conditions:

The above copyright notice and this permission notice shall be included in all copies 
or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, 
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE 
FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR 
OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR 
OTHER DEALINGS IN THE SOFTWARE. 
*/
//---------------------------------------------------------------------------
#ifndef CommH
#define CommH
//---------------------------------------------------------------------------
void Normalise(TDCB *dcb);
void Normalise(TCommConfig *cfg);
AnsiString CommEventToString(DWORD ev);

bool CommConfigDialog(
    AnsiString name,	// device name string
    HWND hWnd,	      // handle to window
    TCommConfig *cfg	// pointer to configuration structure
   );

void BuildCommDCB(
    AnsiString def,	// device-control string
    TDCB *dcb	      // pointer to device-control block
   );

void BuildCommDCBAndTimeouts(
    AnsiString def,	  // device-control string
    TDCB *dcb,	      // pointer to device-control block
    TCommTimeouts *to //pointer to time-out structure
   );

void GetDefaultCommConfig(
    AnsiString name,	// device name string
    TCommConfig *cfg	// pointer to configuration structure
   );

void SetDefaultCommConfig(
    AnsiString name,	// device name string
    TCommConfig *cfg	// pointer to configuration structure
   );

//---------------------------------------------------------------------------
class TComm : public THandleStream {
public:
  __fastcall TComm(const AnsiString &deviceName);
  __fastcall TComm(const AnsiString &deviceName, const AnsiString &cfg);
  virtual __fastcall ~TComm();
  void __fastcall SetDCB(TDCB *dcb);
  void __fastcall GetDCB(TDCB *dcb);
  void __fastcall SetConfig(TCommConfig *cfg);
  void __fastcall GetConfig(TCommConfig *cfg);
  void __fastcall Setup(DWORD inQueue, DWORD outQueue);
  void __fastcall SetTimeouts(TCommTimeouts *to);
  void __fastcall GetTimeouts(TCommTimeouts *to);
  DWORD __fastcall Wait();
  void __fastcall GetStat(COMSTAT *comstat);
  void __fastcall Purge(DWORD mask = PURGE_TXABORT | PURGE_RXABORT |
                                     PURGE_TXCLEAR | PURGE_RXCLEAR);
private:
  void __fastcall SetMask(DWORD value);
  DWORD __fastcall GetMask();
__published:
  __property DWORD Mask  = { read=GetMask, write=SetMask };
};
//---------------------------------------------------------------------------
bool IsComm(const AnsiString &s);
bool IsSocket(const AnsiString &s);
AnsiString GetCommString(const AnsiString &s);
AnsiString GetIPAddr(const AnsiString &s);
int GetIPPort(const AnsiString &s);
//---------------------------------------------------------------------------
class TCommStringParser
{
  public:
    __fastcall TCommStringParser(const AnsiString &s) : SrcString(s) {}
    bool __fastcall GetIsComm();

  protected:
    AnsiString SrcString;
};
//---------------------------------------------------------------------------
#endif
