//---------------------------------------------------------------------------
/*
Copyright (c) 2013 Serge L. Ryadkow admin@opcgate.ru http://opcgate.ru 

Permission is hereby granted, free of charge, to any person obtaining a copy of this 
software and associated documentation files (the "Software"), to deal in the Software 
without restriction, including without limitation the rights to use, copy, modify, 
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to 
permit persons to whom the Software is furnished to do so, subject to the following 
conditions:

The above copyright notice and this permission notice shall be included in all copies 
or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, 
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE 
FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR 
OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR 
OTHER DEALINGS IN THE SOFTWARE. 
*/
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
#include <vcl.h>

#pragma hdrstop

#include "SHA2Str.h"
#include "sha2.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
AnsiString __fastcall SHA256(const AnsiString &s)
{
	char b[SHA256_DIGEST_STRING_LENGTH];
  return AnsiString(SHA256_Data(s.c_str(), s.Length(), b));
}
//---------------------------------------------------------------------------
AnsiString __fastcall SHA256(const AnsiString &s, const AnsiString &salt)
{
  return SHA256(SHA256(s) + salt);
}
//---------------------------------------------------------------------------
AnsiString __fastcall SHA384(const AnsiString &s)
{
	char b[SHA384_DIGEST_STRING_LENGTH];
  return AnsiString(SHA384_Data(s.c_str(), s.Length(), b));
}
//---------------------------------------------------------------------------
AnsiString __fastcall SHA384(const AnsiString &s, const AnsiString &salt)
{
  return SHA384(SHA384(s) + salt);
}
//---------------------------------------------------------------------------
AnsiString __fastcall SHA512(const AnsiString &s)
{
	char b[SHA512_DIGEST_STRING_LENGTH];
  return AnsiString(SHA512_Data(s.c_str(), s.Length(), b));
}
//---------------------------------------------------------------------------
AnsiString __fastcall SHA512(const AnsiString &s, const AnsiString &salt)
{
  return SHA512(SHA512(s) + salt);
}
//---------------------------------------------------------------------------
