//---------------------------------------------------------------------------
/*
Copyright (c) 2013 Serge L. Ryadkow admin@opcgate.ru http://opcgate.ru 

Permission is hereby granted, free of charge, to any person obtaining a copy of this 
software and associated documentation files (the "Software"), to deal in the Software 
without restriction, including without limitation the rights to use, copy, modify, 
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to 
permit persons to whom the Software is furnished to do so, subject to the following 
conditions:

The above copyright notice and this permission notice shall be included in all copies 
or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, 
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE 
FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR 
OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR 
OTHER DEALINGS IN THE SOFTWARE. 
*/
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------

#ifndef StringUtilH
#define StringUtilH
//---------------------------------------------------------------------------
#include <Registry.hpp>
#include <DB.hpp>
#include "ListUtils.h"
//---------------------------------------------------------------------------
const int MinCryptLength = 80;
//---------------------------------------------------------------------------
AnsiString __fastcall Expand(const AnsiString &src, int length);
AnsiString __fastcall Preconv(AnsiString s);
AnsiString __fastcall RemoveComments(AnsiString s, char b = ';');
AnsiString __fastcall RemoveComments(AnsiString s, AnsiString bs);
void __fastcall RemoveComments(TStrings *sl, char b = ';');
void __fastcall RemoveComments(TStrings *sl, AnsiString bs);
void __fastcall RemoveEmptyStrings(TStrings *sl);
bool __fastcall FindEq(AnsiString s, AnsiString &res, AnsiString &expr);
int __fastcall SplitString(const AnsiString &s, TStrings *sl, const AnsiString &ds = " \t");
AnsiString __fastcall GetPart(const AnsiString &s, int i, const AnsiString &ds = " \t");
int __fastcall GetSubStrings(TStrings *src, TStrings *dst, int from, int to);
int __fastcall GetSubStrings(TStrings *src, TStrings *dst,
                             const AnsiString &from, const AnsiString &to);
int __fastcall GetSection(TStrings *src, TStrings *dst,
                          const AnsiString &from, const AnsiString &to);
int __fastcall GetSection(TStrings *sl,
                          const AnsiString &from, const AnsiString &to);
int __fastcall StringToIntList(AnsiString s, TIntList *il, AnsiString ds = " \t,", AnsiString cds = "-");
int __fastcall StringsToIntList(TStrings *sl, TIntList *il, AnsiString ds = " \t,", AnsiString cds = "-");
void __fastcall IntListToStrings(TIntList *il, TStrings *sl);
void __fastcall FillDefaults(TStrings *l, TStrings *dl);
AnsiString __fastcall GetRegStr(TRegistry *reg, AnsiString key);
AnsiString __fastcall Encode(AnsiString s, AnsiString key);
AnsiString __fastcall ReadCrypt(TRegistry *reg, AnsiString name, AnsiString key);
void __fastcall WriteCrypt(TRegistry *reg, AnsiString name, AnsiString s, AnsiString key);
void __fastcall ReadCrypt(TRegistry *reg, AnsiString name, TStrings *sl, AnsiString key);
void __fastcall WriteCrypt(TRegistry *reg, AnsiString name, TStrings *sl, AnsiString key);
void __fastcall Read(TRegistry *reg, TStrings *sl);
void __fastcall Write(TRegistry *reg, TStrings *sl);
AnsiString __fastcall ParamsToString(TParams *p, AnsiString sep = " ,");
AnsiString __fastcall NormPath(AnsiString path);
AnsiString __fastcall Increment(AnsiString s);
AnsiString __fastcall SysTimeToString(const SYSTEMTIME &t);
AnsiString __fastcall SysDateToString(const SYSTEMTIME &t);
AnsiString __fastcall SysDateTimeToString(const SYSTEMTIME &t);
bool __fastcall IsIPAddress(AnsiString s);
//Check if string is hexadecimal value. If precision > 0 then check range also
bool __fastcall IsHex(const AnsiString &s, int precision = 0);
//Convert hexadecimal string to integer
int __fastcall HexToInt(const AnsiString &s, int precision = 0);
AnsiString __fastcall MixString(const AnsiString &s1, const AnsiString &s2);
//---------------------------------------------------------------------------
//void StringToVarList(AnsiString s, AnsiString format, TList *l, TList *defaults, AnsiString ds = " \t,");
//---------------------------------------------------------------------------
AnsiString SubstrFrom(const AnsiString &s, const AnsiString &d);
AnsiString SubstrAfter(const AnsiString &s, const AnsiString &d);
AnsiString SubstrTo(const AnsiString &s, const AnsiString &d);
AnsiString SubstrBefore(const AnsiString &s, const AnsiString &d);
AnsiString SubstrFromTo(const AnsiString &s, const AnsiString &d1, const AnsiString &d2);
AnsiString SubstrAfterBefore(const AnsiString &s, const AnsiString &d1, const AnsiString &d2);
//---------------------------------------------------------------------------
AnsiString __fastcall GuidString();
//---------------------------------------------------------------------------
#endif
