//---------------------------------------------------------------------------
/*
Copyright (c) 2013 Serge L. Ryadkow admin@opcgate.ru http://opcgate.ru 

Permission is hereby granted, free of charge, to any person obtaining a copy of this 
software and associated documentation files (the "Software"), to deal in the Software 
without restriction, including without limitation the rights to use, copy, modify, 
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to 
permit persons to whom the Software is furnished to do so, subject to the following 
conditions:

The above copyright notice and this permission notice shall be included in all copies 
or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, 
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE 
FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR 
OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR 
OTHER DEALINGS IN THE SOFTWARE. 
*/
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
#ifndef UDPSockH
#define UDPSockH
//---------------------------------------------------------------------------
#include <winsock2.h>
//---------------------------------------------------------------------------
class TWSA
{
public:
  TWSA();
  ~TWSA();
	static WSADATA Data;  
private:
  static int RefCnt;
};
//---------------------------------------------------------------------------
class TSockAddr : public sockaddr_in {
public:
  __fastcall TSockAddr(const AnsiString &host, int port);
  __fastcall TSockAddr(int port);
  __fastcall TSockAddr();
  AnsiString __fastcall Host2Str() const;
  AnsiString __fastcall Addr2Str() const;
  operator bool();
  bool operator !();
  TSockAddr& operator =(const TSockAddr &a);
  TSockAddr& operator =(int port);
friend bool operator == (const TSockAddr &a1, const TSockAddr &a2);
friend bool operator != (const TSockAddr &a1, const TSockAddr &a2);
};
//---------------------------------------------------------------------------
class TUDPSocket
{
  public:
    TUDPSocket(int port);
    TUDPSocket();
    ~TUDPSocket();
    int RecvFrom(char *buff, int len, TSockAddr *addr);
    int SendTo(char *buff, int len, TSockAddr *addr);
  private:
    SOCKET Socket;
};
//---------------------------------------------------------------------------
#endif
