//---------------------------------------------------------------------------
/*
Copyright (c) 2013 Serge L. Ryadkow admin@opcgate.ru http://opcgate.ru 

Permission is hereby granted, free of charge, to any person obtaining a copy of this 
software and associated documentation files (the "Software"), to deal in the Software 
without restriction, including without limitation the rights to use, copy, modify, 
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to 
permit persons to whom the Software is furnished to do so, subject to the following 
conditions:

The above copyright notice and this permission notice shall be included in all copies 
or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, 
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE 
FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR 
OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR 
OTHER DEALINGS IN THE SOFTWARE. 
*/
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------

#ifndef UtilH
#define UtilH
//---------------------------------------------------------------------------
#include <Registry.hpp>
#include "ListUtils.h"
//---------------------------------------------------------------------------
extern const double BadD;
double Round(const double &v);
long double Round(const long double &v);
TDateTime LastCycle(TDateTime cycle, TDateTime time);
TDateTime NextCycle(TDateTime cycle, TDateTime time);
TDateTime NearCycle(TDateTime cycle, TDateTime time);
AnsiString TimeToHex(TDateTime t);
TDateTime HexToTime(const AnsiString &s);
TDateTime SecToTime(int s);
HANDLE CheckFileHandle(HANDLE h);
TDateTime __fastcall MSToDateTime(int ms);
TDateTime __fastcall SToDateTime(int s);
class TTimeout {
  public:
    __fastcall TTimeout(TDateTime t);
    __fastcall TTimeout(int ms);
    bool __fastcall Check();
  private:
    TDateTime Time;
};
AnsiString __fastcall GetRegStr(TRegistry *reg, AnsiString key);
void __fastcall DateTimeToFileTime(TDateTime dt, TFileTime &ft);
void __fastcall FileTimeToDateTime(TDateTime &dt, const TFileTime &ft);
TDateTime __fastcall FileTimeToDateTime(const TFileTime &ft);
void __fastcall Pack(void *buff, void *data, int offset, int bits);
void __fastcall UnPack(void *buff, void *data, int offset, int bits);
void __fastcall Pack(void *buff, void *data, int offset, int bits, void *wb);
void __fastcall ShiftR(void *buff, int offset, int bytes);
void __fastcall ShiftL(void *buff, int offset, int bytes);
void __fastcall Enable(TControl *c, bool enable);
void __fastcall ExitWindowsEx(UINT flags); //for flags see API ExitWindowsEx()
TDateTime __fastcall LocalToGmt(const TDateTime &t);
TDateTime __fastcall GmtToLocal(const TDateTime &t);
int __fastcall GetIEVersion();
//---------------------------------------------------------------------------
const int LOCKATTEMPTS			=	30;
const int LOCKDELAY					=	1000;
//---------------------------------------------------------------------------
class TFileLock {
	public:
	 	TFileLock(THandleStream *s);
	 	TFileLock(THandleStream *s, int attempts, int attemptTimeout);
	 	TFileLock(THandleStream *s, int attempts, int attemptTimeout,
              int from, int length);
	 	~TFileLock();
  private:
  	HANDLE Handle;
    int From;
    int Length;
};
//---------------------------------------------------------------------------
#endif
