//---------------------------------------------------------------------------
/*
OPCGate - open source software, which is the OPC-Gateway, 
allowing the simplest way to add functionality of the OPC DA server 
to custom programs.

Copyright (C) 2013 Serge L. Ryadkow

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

Contacts:
admin@opcgate.ru
http://opcgate.ru
*/
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
#ifndef ClientUH
#define ClientUH
//---------------------------------------------------------------------------
#include <IdTCPClient.hpp>

#include <SSLIntercept.hpp>
#include <SSLOpenSSL.hpp>
//---------------------------------------------------------------------------
class TClient {
public:
	__fastcall TClient();
	__fastcall ~TClient();
  void __fastcall Connect();
  void __fastcall Disconnect();
  bool __fastcall Connected();
  void __fastcall Send(const AnsiString &s);
  AnsiString __fastcall Receive(int to);
private:
	void __fastcall OnConnected(TObject *Sender);
	void __fastcall OnDisconnected(TObject *Sender);
	void __fastcall OnStatus(TObject *Sender,
  		const TIdStatus sts, const AnsiString msg);
  class TSocket : public TIdTCPClient {
  public:
  	__fastcall TSocket(TClient *owner);
  	__fastcall ~TSocket();
  private:
		void __fastcall SSLConnect(TObject *Sender);
		void __fastcall SSLStatusInfo(AnsiString msg);
		bool __fastcall SSLVerifyPeer(TX509 *cert, int ok);
  	TConnectionInterceptOpenSSL *SSL;
  } *Socket;
friend class TSocket;
};
//---------------------------------------------------------------------------
extern TClient *Client;
//---------------------------------------------------------------------------
#endif
