//---------------------------------------------------------------------------
/*
OPCGate - open source software, which is the OPC-Gateway, 
allowing the simplest way to add functionality of the OPC DA server 
to custom programs.

Copyright (C) 2013 Serge L. Ryadkow

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

Contacts:
admin@opcgate.ru
http://opcgate.ru
*/
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
#include <vcl.h>

#pragma hdrstop

#include <dir.h>

#include <StringUtil.h>

#include "ConfigU.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
TConfig *Config = 0;
//---------------------------------------------------------------------------
__fastcall TConfig::TConfig()
{
	char b[MAXPATH + 1];
  ::GetModuleFileName(::GetModuleHandle(0), b, MAX_PATH);
  ModulePath = AnsiString(b);
  ModuleDir = ::ExtractFilePath(ModulePath);
	TStringList *sl = new TStringList();
  try {
	 	sl->LoadFromFile(::ChangeFileExt(ModulePath, ".cfg"));
  	::RemoveComments(sl, '#');
#define CFGITEM(name, type) try { Convert(Data.##name, sl->Values[#name]); \
    } catch(Exception &e) {e.Message = "Config."#name" error: " + e.Message; \
    throw;}
#include "Config.templ"
#undef CFGITEM
  } __finally {
  	delete sl;
  }
  if (!Data.Title.IsEmpty())
  	::SetConsoleTitle(Data.Title.c_str());
  if (Data.HideConsole) {
  	HWND hWnd = GetConsoleWindow();
    ShowWindow(hWnd, SW_HIDE);
  }
}
//---------------------------------------------------------------------------
__fastcall TConfig::~TConfig()
{
}
//---------------------------------------------------------------------------
AnsiString __fastcall TConfig::ToString()
{
	AnsiString s = "Config:";
#define CFGITEM(name, type) s += "\n\t"#type" "#name" = " + \
		AnsiString(Data.##name) + ";";
#include "Config.templ"
#undef CFGITEM
	return s;
}
//---------------------------------------------------------------------------

