//---------------------------------------------------------------------------
/*
OPCGate - open source software, which is the OPC-Gateway, 
allowing the simplest way to add functionality of the OPC DA server 
to custom programs.

Copyright (C) 2013 Serge L. Ryadkow

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

Contacts:
admin@opcgate.ru
http://opcgate.ru
*/
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
#ifndef ConfigUH
#define ConfigUH
//---------------------------------------------------------------------------
class TConfig {
public:
	__fastcall TConfig();
	__fastcall ~TConfig();
  AnsiString __fastcall GetModulePath() {return ModulePath;}
  AnsiString __fastcall GetModuleDir() {return ModuleDir;}
#define CFGITEM(name, type) type __fastcall Get##name() {return Data.##name;}
#include "Config.templ"
#undef CFGITEM
  AnsiString __fastcall ToString();
private:
	template<class T> void __fastcall Convert(T &res, const AnsiString &val);
	void __fastcall Convert(int &res, const AnsiString &val);
	void __fastcall Convert(double &res, const AnsiString &val);
  AnsiString ModulePath, ModuleDir;
  struct {
#define CFGITEM(name, type) type name;
#include "Config.templ"
#undef CFGITEM
  } Data;
};
//---------------------------------------------------------------------------
template<class T>
inline void __fastcall TConfig::Convert(T &res, const AnsiString &val)
{
	res = val;
}
//---------------------------------------------------------------------------
inline void __fastcall TConfig::Convert(int &res, const AnsiString &val)
{
	res = val.ToInt();
}
//---------------------------------------------------------------------------
inline void __fastcall TConfig::Convert(double &res, const AnsiString &val)
{
	res = val.ToDouble();
}
//---------------------------------------------------------------------------
extern TConfig *Config;
//---------------------------------------------------------------------------
#endif
