//---------------------------------------------------------------------------
/*
OPCGate - open source software, which is the OPC-Gateway, 
allowing the simplest way to add functionality of the OPC DA server 
to custom programs.

Copyright (C) 2013 Serge L. Ryadkow

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

Contacts:
admin@opcgate.ru
http://opcgate.ru
*/
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
#ifndef LogFileUH
#define LogFileUH
//---------------------------------------------------------------------------
#include <fstream.h>
#include <SyncObjs.hpp>
//---------------------------------------------------------------------------
enum TLogFlag {
  lfError               = 0x0001,
  lfStartStop           = 0x0002,
  lfCfg		           		= 0x0004,
  lfSSL									=	0x0008,
  lfClient							=	0x0010,
  lfTags								=	0x0020,
  lfServer							=	0x0040,
  lfProtocol						=	0x0080,
};
//---------------------------------------------------------------------------
class TLogFile {
public:
  __fastcall TLogFile();
  __fastcall ~TLogFile();
  bool __fastcall CheckFlag(TLogFlag f) {return Flags & f;}
  void __fastcall Log(const AnsiString &s);
  void __fastcall Log(Exception &e, const AnsiString &info);
private:
  TCriticalSection *CS;
  ofstream *LogFile, *ErrFile;
  TLogFlag Flags;
};
//---------------------------------------------------------------------------
extern TLogFile *LogFile;
//---------------------------------------------------------------------------
#endif
 