//---------------------------------------------------------------------------
/*
OPCGate - open source software, which is the OPC-Gateway, 
allowing the simplest way to add functionality of the OPC DA server 
to custom programs.

Copyright (C) 2013 Serge L. Ryadkow

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

Contacts:
admin@opcgate.ru
http://opcgate.ru
*/
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
#ifndef ProtocolUH
#define ProtocolUH
//---------------------------------------------------------------------------
class TProtocol {
public:
  __fastcall TProtocol();
  __fastcall ~TProtocol();
  void __fastcall Start();
  void __fastcall Stop();
	void __fastcall GetTags(TStrings *sl);
private:
  AnsiString __fastcall GetHash();
	void __fastcall GetValues(TStrings *sl);
	int __fastcall GetSubsValues(TStrings *sl);
	void __fastcall Subscribe();
	void __fastcall SetConnTO();
	void __fastcall SetSubsTO();
	void __fastcall Ping();
  class TThrd : public TThread {
  public:
  	__fastcall TThrd(TProtocol *prot);
  	__fastcall ~TThrd();
  private:
  	virtual void __fastcall Execute();
    TProtocol *Prot;
    int Cycle;
    TDateTime PingTime;
    enum TSts {
      sInit,
      sDisconn,
      sConn,
      sSubscr,
      //
      sBadHash
    } Sts;
  } *Thread;
friend class TThrd;  
};
//---------------------------------------------------------------------------
extern TProtocol *Protocol;
//---------------------------------------------------------------------------
#endif
