//---------------------------------------------------------------------------
/*
OPCGate - open source software, which is the OPC-Gateway, 
allowing the simplest way to add functionality of the OPC DA server 
to custom programs.

Copyright (C) 2013 Serge L. Ryadkow

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

Contacts:
admin@opcgate.ru
http://opcgate.ru
*/
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
#ifndef ServerUH
#define ServerUH
//---------------------------------------------------------------------------
class TOPCSrvr;
//---------------------------------------------------------------------------
class TServer {
public:
	__fastcall TServer();
	__fastcall ~TServer();
  static void __fastcall Configure();
  void __fastcall Start();
  void __fastcall Stop();
  void __fastcall SetValues(TStrings *sl);
  void __fastcall SetBad();
  void __fastcall SetSTConnections(bool val);
  void __fastcall SetSTTagsHashGood(bool val);
private:
	TOPCSrvr *OPC;
  int N;
  enum TType {
  	tB,
    tI1,
    tU1,
    tI2,
    tU2,
    tI4,
    tU4,
    tR4,
    tR8
  } *Types;
  enum TSysTags {
  	stConnection = 1,
    stTagsHashGood,
    //
    stSysTagsCount
  };
};
//---------------------------------------------------------------------------
extern TServer *Server;
//---------------------------------------------------------------------------
#endif
