//---------------------------------------------------------------------------
/*
OPCGate - open source software, which is the OPC-Gateway, 
allowing the simplest way to add functionality of the OPC DA server 
to custom programs.

Copyright (C) 2013 Serge L. Ryadkow

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

Contacts:
admin@opcgate.ru
http://opcgate.ru
*/
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
#include <vcl.h>

#pragma hdrstop

#include <SHA2Str.h>

#include "TagsU.h"
#include "ConfigU.h"
#include "LogFileU.h"
#include "CmdParsU.h"
#include "ProtocolU.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
TTags *Tags;
//---------------------------------------------------------------------------
__fastcall TTags::TTags()
	:	FileName(ChangeFileExt(Config->GetModulePath(), ".tag"))
{
	List = new TStringList();
  if (!CmdLineParser->GetTagsF()) {
	  if (FileExists(FileName)) {
  		List->LoadFromFile(FileName);
    	Count = List->Count;
	  } else
  		Count = 0;
  } else {
	  if (LogFile->CheckFlag(lfTags))
		  LogFile->Log("Request tags from server...");
    Protocol->GetTags(List);
    Count = List->Count;
 		List->SaveToFile(FileName);
  }
  if (LogFile->CheckFlag(lfTags))
	  LogFile->Log("TagsCount: " + AnsiString(Count));
  Hash = SHA256(List->Text);
  if (LogFile->CheckFlag(lfTags))
	  LogFile->Log("TagsHash: " + Hash);
}
//---------------------------------------------------------------------------
__fastcall TTags::~TTags()
{
	delete List;
}
//---------------------------------------------------------------------------
