//---------------------------------------------------------------------------
/*
Copyright (c) 2013 Serge L. Ryadkow admin@opcgate.ru http://opcgate.ru 

Permission is hereby granted, free of charge, to any person obtaining a copy of this 
software and associated documentation files (the "Software"), to deal in the Software 
without restriction, including without limitation the rights to use, copy, modify, 
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to 
permit persons to whom the Software is furnished to do so, subject to the following 
conditions:

The above copyright notice and this permission notice shall be included in all copies 
or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, 
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE 
FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR 
OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR 
OTHER DEALINGS IN THE SOFTWARE. 
*/
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
#ifndef GateH
#define GateH
//---------------------------------------------------------------------------
#include <IdTCPServer.hpp>

#include <SSLIntercept.hpp>
#include <SSLOpenSSL.hpp>
//---------------------------------------------------------------------------
/*

     :
  virtual void __fastcall GetValues(TStrings *sl) = 0;
  virtual void __fastcall Log(const AnsiString &msg) = 0;
  virtual void __fastcall GetTags(TStrings *sl) = 0;
    (   )
  void __fastcall SetValues(TStrings *sl);


  virtual void __fastcall GetValues(TStrings *sl) = 0;
-       
(   ,  -  )

  virtual void __fastcall Log(const AnsiString &msg) = 0;
-     

  virtual void __fastcall GetTags(TStrings *sl) = 0;
-       
(   ,  -  )

  void __fastcall SetValues(TStrings *sl);
-        ,
(     -  )


    -    :
-   (  1)
-  (  - )
- :
	b - bool
  i1 - char
  u1 - unsigned char
  i2 - short
  u2 - unsigned short
  i4 - long
  u4 - unsigned long
  r4 - float
  r8 - double
- :
	r - read
  rw - read/write

example: 1 group1.tag1 r4 r

    -    :
-   (  1)
- ()
-:
	b - bad
  g - good
-
-

,   
int port -  
const AnsiString &certFile -   
const AnsiString &keyFile -   
const AnsiString &rootCertFile -   
TLogFlags logFlags -     
int connTOms -    (),  
	  ,     ,   .
int subsTOms -       (),
	 	  ,     ,
    .
bool buffSubs -  ,    .
*/
//---------------------------------------------------------------------------
namespace OPCGate {
//---------------------------------------------------------------------------
class TProtocol;
//---------------------------------------------------------------------------
class TOPCGate {
public:
	enum TLogFlags {
  	lfNone			=	0x0000,
  	lfError			=	0x0001,
    lfIntercept	=	0x0002,
    lfServer		=	0x0004,
    lfProtocol	=	0x0008
  };
	__fastcall TOPCGate(int port, TLogFlags logFlags,
  		int connTOms, int subsTOms, bool buffSubs);
	__fastcall TOPCGate(int port, const AnsiString &certFile,
			const AnsiString &keyFile, const AnsiString &rootCertFile,
      TLogFlags logFlags, int connTOms, int subsTOms, bool buffSubs);
	__fastcall ~TOPCGate();
  void __fastcall Start();
  void __fastcall Stop();
  //interface: initiator - application, TStrings owner - application
  void __fastcall SetValues(TStrings *sl);
  //interface: initiator - library, TStrings owner - library
  virtual void __fastcall GetValues(TStrings *sl) = 0;
  //end interface
  virtual void __fastcall Log(const AnsiString &msg) = 0;
  TStrings* __fastcall GetTags() {return Tags;}
  const AnsiString& __fastcall GetTagsHash() {return TagsHash;}
  static AnsiString __fastcall FormatVal(int idx, bool val, bool good,
  		const TDateTime &dt);
  static AnsiString __fastcall FormatVal(int idx, char val, bool good,
  		const TDateTime &dt);
  static AnsiString __fastcall FormatVal(int idx, unsigned char val, bool good,
  		const TDateTime &dt);
  static AnsiString __fastcall FormatVal(int idx, short val, bool good,
  		const TDateTime &dt);
  static AnsiString __fastcall FormatVal(int idx, unsigned short val, bool good,
  		const TDateTime &dt);
  static AnsiString __fastcall FormatVal(int idx, int val, bool good,
  		const TDateTime &dt);
  static AnsiString __fastcall FormatVal(int idx, unsigned int val, bool good,
  		const TDateTime &dt);
  static AnsiString __fastcall FormatVal(int idx, long val, bool good,
  		const TDateTime &dt);
  static AnsiString __fastcall FormatVal(int idx, unsigned long val, bool good,
  		const TDateTime &dt);
  static AnsiString __fastcall FormatVal(int idx, float val, bool good,
  		const TDateTime &dt);
  static AnsiString __fastcall FormatVal(int idx, double val, bool good,
  		const TDateTime &dt);
  const TLogFlags LogFlags;
private:
  //interface: initiator - library, TStrings owner - library
  virtual void __fastcall GetTags(TStrings *sl) = 0;
  //end interface
	void __fastcall InterceptStatus(AnsiString msg);
	bool __fastcall InterceptVerifyPeer(TX509 *cert, int ok);
	void __fastcall ServerExecute(TIdPeerThread *thread);
	void __fastcall ServerConnect(TIdPeerThread *thread);
	void __fastcall ServerDisconnect(TIdPeerThread *thread);
	void __fastcall ServerStatus(TObject *sender, const TIdStatus sts,
  		const AnsiString msg);
	TIdTCPServer *Server;
  TServerInterceptOpenSSL *Intercept;
  TProtocol *Protocol;
  TStringList *Tags;
  AnsiString TagsHash;
};
//---------------------------------------------------------------------------
} //namespace OPCGate
using namespace OPCGate;
//---------------------------------------------------------------------------
#endif
