//---------------------------------------------------------------------------
/*
Copyright (c) 2013 Serge L. Ryadkow admin@opcgate.ru http://opcgate.ru 

Permission is hereby granted, free of charge, to any person obtaining a copy of this 
software and associated documentation files (the "Software"), to deal in the Software 
without restriction, including without limitation the rights to use, copy, modify, 
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to 
permit persons to whom the Software is furnished to do so, subject to the following 
conditions:

The above copyright notice and this permission notice shall be included in all copies 
or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, 
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE 
FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR 
OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR 
OTHER DEALINGS IN THE SOFTWARE. 
*/
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
#ifndef ProtocolH
#define ProtocolH
//---------------------------------------------------------------------------
#include <IdBaseComponent.hpp>
#include <IdComponent.hpp>
#include <IdTCPServer.hpp>
#include <IdIntercept.hpp>
#include <IdSSLIntercept.hpp>
#include <IdSSLOpenSSL.hpp>
//---------------------------------------------------------------------------
namespace OPCGate {
//---------------------------------------------------------------------------
class TOPCGate;
class TSession;
//---------------------------------------------------------------------------
class TProtocol {
public:
	__fastcall TProtocol(TOPCGate *gate, int connTOms, int subsTOms,
  		bool buffSubs);
	__fastcall ~TProtocol();
  bool __fastcall Execute(TIdPeerThread *thread);
  void __fastcall SendToSubscr(TIdPeerThread *thread, TStrings *sl);
private:
	void __fastcall HandleQuit(TSession *sess, TIdTCPServerConnection *conn);
	void __fastcall HandlePing(TSession *sess);
	void __fastcall HandleHash(TSession *sess, TIdTCPServerConnection *conn);
	void __fastcall HandleTags(TSession *sess, TIdTCPServerConnection *conn);
	void __fastcall HandleValues(TSession *sess, TIdTCPServerConnection *conn);
	void __fastcall HandleSubscr(TSession *sess, TIdTCPServerConnection *conn);
	void __fastcall HandleUnsubscr(TSession *sess, TIdTCPServerConnection *conn);
	void __fastcall HandleParConnTO(TSession *sess, TIdTCPServerConnection *conn,
  		int v);
	void __fastcall HandleParSubsTO(TSession *sess, TIdTCPServerConnection *conn,
  		int v);
	TOPCGate *Gate;
  const int ConnTOms, SubsTOms;
  const bool BuffSubs;
};
//---------------------------------------------------------------------------
} //namespace OPCGate
using namespace OPCGate;
//---------------------------------------------------------------------------
#endif
 