//---------------------------------------------------------------------------
/*
Copyright (c) 2013 Serge L. Ryadkow admin@opcgate.ru http://opcgate.ru 

Permission is hereby granted, free of charge, to any person obtaining a copy of this 
software and associated documentation files (the "Software"), to deal in the Software 
without restriction, including without limitation the rights to use, copy, modify, 
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to 
permit persons to whom the Software is furnished to do so, subject to the following 
conditions:

The above copyright notice and this permission notice shall be included in all copies 
or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, 
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE 
FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR 
OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR 
OTHER DEALINGS IN THE SOFTWARE. 
*/
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------

#ifndef MainUH
#define MainUH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ImgList.hpp>
#include <ExtCtrls.hpp>
#include <Buttons.hpp>
//---------------------------------------------------------------------------
class TOPCServer;
class TAsyncOPCGroup;
//---------------------------------------------------------------------------
class TMainF : public TForm
{
__published:	// IDE-managed Components
	TTreeView *Tree;
	TImageList *ImageList1;
	TTimer *Timer1;
	TPanel *Panel1;
	TLabel *Label1;
	TStaticText *ServerTimeST;
	TLabel *Label2;
	TLabel *Label3;
	TPanel *Panel2;
	TLabel *Label5;
	TComboBox *ServerCB;
	TBitBtn *StartB;
	TBitBtn *StopB;
	TCheckBox *ExpandCB;
	void __fastcall Timer1Timer(TObject *Sender);
	void __fastcall Label3Click(TObject *Sender);
	void __fastcall StartBClick(TObject *Sender);
	void __fastcall StopBClick(TObject *Sender);
private:	// User declarations
	void __fastcall Connect();
	void __fastcall Disconnect();
  void __fastcall OnChange(TAsyncOPCGroup *group, int count, int *i);
	void __fastcall OnIdle(System::TObject* Sender, bool &Done);
	TOPCServer *Server;
  TAsyncOPCGroup *Group;
  TTreeNode **Nodes;
  int NodeCnt;
  bool UF, RF;
public:		// User declarations
	__fastcall TMainF(TComponent* Owner);
	__fastcall ~TMainF();
};
//---------------------------------------------------------------------------
extern PACKAGE TMainF *MainF;
//---------------------------------------------------------------------------
struct TNodeData {
	AnsiString Tag;
};
//---------------------------------------------------------------------------
typedef TTreeNode *PTreeNode;
//---------------------------------------------------------------------------
#endif
